/****************************************************************/
/*              Reductions Application Suite                    */
/****************************************************************/

#include<stdio.h>
#include<stdlib.h>
#include<assert.h>
#include "timers.h"

int main(int argc, char*argv[])
{

    if(argc != 3)
    {
        printf("./array_sum n bs\n");
        exit(1);
    }
    int N = atoi( argv[1] );
    int BS = atoi( argv[2] );
    
    int i, res = 0, *v;
    v = malloc(N*sizeof(int));

    for (i = 0; i < N; ++i) v[i] = i + 1;

    for (i = 0; i < N; i+=BS)
    {
        #pragma omp task reduction(+: res)
        {
            int j;
            for(j = 0; j < BS && (i+j) < N; ++j)
            {
                res += v[i+j]; 
            }
        }
    }

#pragma omp taskwait
    printf("computed result: %d vs. real result: %d\n", res, ((N*(N+1))/2));
    assert(res == ((N*(N+1))/2));
    printf("ok!\n");
}
