/****************************************************************/
/*              Reductions Application Suite                    */
/****************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include<assert.h>
typedef struct
{
	int x, y;
} move;

#define true 1
#define false 0

move vector_add (move *a, move *b)
{
	move c;
	c.x = a->x + b->x;
	c.y = a->y + b->y;
	return c;
}

move moves[8]={{2,1},{2,-1},{-2,1},{-2,-1},{1,2},{-1,2},{1,-2},{-1,-2}}; //valid positions for a move

int N, *board, final;
int total_solutions;

int findtour(int move_num, move m, int _board [N*N])
{
	//check final position
	if(move_num == (N*N))
	{
        int j;
        for (j = 0; j < N*N; ++j)
        {
            assert(board[j]);
        }
		return 1;
	}

	//test all new possible moves
	int sum = 0, i;
	for(i = 0; i < 8; i++)
    {
        move new_move = vector_add(&m, &moves[i]);
        int pos = new_move.y * N + new_move.x;
        if (!((new_move.x < 0) || (new_move.x >= N) || (new_move.y < 0) || (new_move.y >= N))
                    && !board[pos])
        {
	            board[pos] = true;
                int tmp = findtour(move_num+1, new_move, _board);
	            board[pos] = false;
                sum = sum + tmp;
        }
    }

	#pragma omp taskwait
	return sum;
}

int main(int argc, char **argv)
{
    if(argc != 3)
    {
        printf("./knights N FINAL\n");
        exit(1);
    }

    N = atoi(argv[1]);
    final = atoi(argv[2]);

    total_solutions = 0;

	int n_solutions = 0, i;
	move move = {0,0};
	board = malloc (sizeof(int) * N*N);
    for (i = 0; i < N*N;++i)
    {
        memset(board, false, sizeof(int) * N*N);
        move.x = i % N;
        move.y = i / N;
        board[i] = true;
         n_solutions += findtour(1, move, board);
        board[i] = false;

        printf("%i\n", n_solutions);
    }

		printf("Total:%i\n", n_solutions);
	return 0;
}

