/****************************************************************/
/*              Reductions Application Suite                    */
/****************************************************************/

#include<stdio.h>
#include<stdlib.h>
#include<assert.h>

int power(int base, int exp)
{
    int result = 1;
    int i;
    for (i = 0; i < exp; ++i)
    {
        result *= base;
    }
    return result;
}

int final_depth;
int global_var;

int nbinarywords(int n, int word_length)
{
    if (word_length == n)
    {
        return 1;
    }
    int i;
    for (i = 0; i < 2; ++i) // loop over the binary alphabet: {0, 1}
    {
        #pragma omp task concurrent(global_var) final(final_depth <= word_length)
        {
            int tmp = nbinarywords(n, word_length + 1);
            #pragma omp atomic
            global_var+= tmp;
        }
    }
    #pragma omp taskwait
    return 0;
}

int main(int argc, char*argv[])
{

    if(argc != 3)
    {
        printf("./nbinarywords n final_depth\n");
        exit(1);
    }

    int n = atoi(argv[1]);
    final_depth = atoi(argv[2]);

    global_var = 0;
    nbinarywords(n, 0);

    printf("%d is %d?\n", global_var, power(2, n));
    assert(global_var == power(2, n));
    printf("ok!\n");
}
