/****************************************************************/
/*              Reductions Application Suite                    */
/****************************************************************/

#include<stdio.h>
#include<stdlib.h>
#include<assert.h>
#include "timers.h"

int power(int base, int exp)
{
    int result = 1;
    int i;
    for (i = 0; i < exp; ++i)
    {
        result *= base;
    }
    return result;
}

int final_depth;
int nbinarywords(int n, int word_length)
{
    if (word_length == n)
    {
        return 1;
    }
    int i;
    int result = 0;
    for (i = 0; i < 2; ++i) // loop over the binary alphabet: {0, 1}
    {
        //#pragma omp task reduction(+: result) final(final_depth <= word_length)
        {
            int tmp = nbinarywords(n, word_length + 1);
            result += tmp;
        }
    }
   // #pragma omp taskwait
    return result;
}

int main(int argc, char*argv[])
{

    if(argc != 3)
    {
        printf("./nbinarywords n final_depth\n");
        exit(1);
    }

    int n = atoi(argv[1]);
    final_depth = atoi(argv[2]);

    timer_start(0);
    int result = nbinarywords(n, 0);
    timer_stop(0);

    printf("%.6f, %i, %i, %i\n", timer_read(0), \
        		result,\
        		omp_get_num_threads(), \
        		final_depth);
    //printf("%d is %d?\n", result, power(2, n));
    assert(result == power(2, n));
   // printf("ok!\n");
}
