/****************************************************************/
/*              Reductions Application Suite                    */
/****************************************************************/

#include<stdio.h>
#include<stdlib.h>
#include<assert.h>
#include "timers.h"

int power(int base, int exp)
{
    int result = 1;
    int i;
    for (i = 0; i < exp; ++i)
    {
        result *= base;
    }
    return result;
}

int final_depth;

int powerset(int n, int index)
{
    int i;
    int res = 0;
    for (i = index; i < n; ++i)
    {
        #pragma omp task final(final_depth <= index)
        {
            int tmp = powerset(n, i+1);
			#pragma omp atomic
            res += tmp + 1;
        }
    }
    #pragma omp taskwait
    return res;
}

int main(int argc, char*argv[])
{

    if(argc != 3)
    {
        printf("./powerset set_size final_depth\n");
        exit(1);
    }
    int n = atoi( argv[1] );
    final_depth = atoi( argv[2] );

    timer_start(0);
    int result = powerset(n, 0) + /* empty set! */ 1;
    timer_stop(0);

    printf("%.6f, %i, %i\n", timer_read(0), final_depth, omp_get_num_threads());
    assert(result == power(2, n));
}
