/****************************************************************/
/*              Reductions Application Suite                    */
/****************************************************************/

#include<stdio.h>
#include<stdlib.h>
#include<assert.h>
#include "timers.h"
int power(int base, int exp)
{
    int result = 1;
    int i;
    for (i = 0; i < exp; ++i)
    {
        result *= base;
    }
    return result;
}

int final_depth;
int global_var;

void powerset(int n, int index)
{
    int i;
    for (i = index; i < n; ++i)
    {
        #pragma omp task reduction(+: global_var) final(final_depth <= index)
        {
            powerset(n, i+1);
            global_var++;
        }
    }
    #pragma omp taskwait
}

int main(int argc, char*argv[])
{

    if(argc != 3)
    {
        printf("./powerset set_size final_depth\n");
        exit(1);
    }
    int n = atoi( argv[1] );
    final_depth = atoi( argv[2] );

    global_var = 1; /* by default is 1 because the powerset of any set always contains the empty set */
    timer_start(0);
    powerset(n, 0);
    timer_stop(0);

    //printf("%d is %d?\n", global_var, power(2, n));
    printf("%.6f, %i, %i\n", timer_read(0), final_depth, omp_get_num_threads());
    assert(global_var == power(2, n));
    //printf("ok!\n");
}
